# mzanalytics

A mzanalytics flutter plugin project.


# 准备工作 🍭

##版本限制

Flutter SDK：`>=1.17.0` 。


##Flutter

将`mzanalytics `添加至`pubspec.yaml`引用。

```   
dependencies:  
  mzanalytics: ^latest_version
```   

在flutter项目中运行  `flutter pub get` 

##iOS运行环境配置
1. cd到iOS项目目录。
2. 终端执行  `pod install`。
3. 打开`Runner.xcworkspace` ,在`Pods->Development->mzanalytics->..->Classes中找到sdkconfig.xml`, 拖到工程项目Runner中。

##Android运行环境配置
 

#####1. 进入到android项目目录app/src/main中。
#####2. 拷贝assets文件夹(包含sdkconfig.xml和supplierconfig.json)到main目录下。
#####3. 在的application标签中添加属性（appkey为纯数字）： 
	<meta-data
       android:name="com.miaozhen.mzsdk.appKey"
       android:value="xxxx" />
    <meta-data
       android:name="com.miaozhen.mzsdk.channelId"
       android:value="xxxxx" />

#使用

####flutter代码中引入头文件:
`
import 'package:mzanalytics/mzanalytics.dart';
`
##iOS示例方法

#####具体传参规则请参考 `MZAnalytics*_*IOS*_*SDK部署指南`


#####初始化SDK 使用时将xxxx替换为实际的AppId
		Mzanalytics.ios_appid("xxxx");

#####页面监测 
		Mzanalytics.ios_trackPageView({
		  'pageTitle': "页面名称"
		});

#####自定义事件
		Mzanalytics.ios_trackEvent({
		  'eventClassify': '点击热门banner',
		  'eventAction': 'Click',
		  'eventTag': '点击'
		});

#####高级自定义事件  没有自定义维度时，customDimMetrics可不传。
		Mzanalytics.ios_trackSiteCustomEvent({
		  'CustomEvent': {
		    "customActionId": "1",
		    "customActionLabel1": "2020/01/10",
		    "customActionLabel2": "15728749249",
		    "customActionLabel3": "北京",
		    "customActionValue1": "1"
		  },
		  'CustomDimMetrics': {
		    "customDimension1": "点击信用卡",
		    "customDimension2": "查看商品详情",
		    "customMetrics1": "点击信用卡总用户数",
		    "customMetrics2": "查看商品详情总用户数"
		  }
		});

#####页面隐藏或关闭（关闭页面或进入后台时调用）
   	 Mzanalytics.ios_trackPulse;

#####获取访客id（设备唯一ID）
   	 Mzanalytics.ios_getCid;

#####deeplink url为deeplink拉起App时接受到的url
   	 Mzanalytics.ios_handleOpenURL(url);

#####打印日志
   	 Mzanalytics.ios_setEnableLog(true);





###Android调用示例

#####具体传参规则请参考 `MZAnalytics*_*Android*_*SDK部署指南`


#####初始化事件：
    try {
      Mzanalytics.android_initEvent();
    } on PlatformException {}


#####基础事件：
    try {
      Mzanalytics.android_sendBaseEvent({
        "dt": '首⻚⻚面',
        "ec": '点击热⻔banner',
        "ea": 'Click',
        "el": '点击',
        "ev": '10',
      });
    } on PlatformException {}


#####页面事件事件：
     try {
      Mzanalytics.android_pageEvent({
        "dt": '底部导航栏',
      });
    } on PlatformException {}

#####高级事件：
    try {
      Mzanalytics.android_seniorEvent({
        "cal1": '提交订单',
        "cal2": '支付订单',
        "cav1": '提交订单数',
        "cav2": '支付订单数',
        "caid": '1',
      });
    } on PlatformException {}
#####心跳事件：
     try {
      Mzanalytics.android_heartEvent();
    } on PlatformException {}
    
    
